﻿namespace TabsStudioCloseClick
{
    public class CloseClick : TabsStudioExt.ITabsStudioAddin
    {
        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine_, EnvDTE80.DTE2 dte_)
        {
            engine = engine_;
            dte = dte_;
            engine.TabCreated += OnTabCreated;
            engine.TabDestroyed += OnTabDestroyed;
        }

        public void OnDisconnection()
        {
            engine.TabCreated -= OnTabCreated;
            engine.TabDestroyed -= OnTabDestroyed;
        }

        private void OnTabCreated(object sender, TabsStudioExt.TabEventArgs e)
        {
            e.Tab.TabItem.MouseDoubleClick += OnTabDoubleClick;
        }

        private void OnTabDestroyed(object sender, TabsStudioExt.TabEventArgs e)
        {
            e.Tab.TabItem.MouseDoubleClick -= OnTabDoubleClick;
        }

        private void OnTabDoubleClick(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            dte.ExecuteCommand("TabsStudio.Connect.CloseTab", "");
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private EnvDTE80.DTE2 dte;
    }
}
